%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% StemGL_Fit Single stem Greenlab Fitting tool and
% StemGL_Sim Single stem GreenLab Simulation tool
%
%   MatLab_Octave code. 
%
% This code is part of GREENLAB project StemGL implementation
%
% Main Author: Philippe de Reffye CIRAD-AMAP
% Secondary author: Marc JAEGER CIRAD-AMAP
%
% Created: 2018
% Version 18_10_05
%
% Copyright (C) 2018 CIRAD-AMAP 
%
% This program is free software: you can redistribute it and/or modify it
% under the terms of the Create Commons Licence  type 5, BY-NC-SA
% BY (Attribution): Licensees may copy, distribute, display and perform the work and make derivative
% works and remixes based on it only if they give the author or licensor the credits (attribution)
% in the manner specified by these.
% SA (Share-alike): Licensees may distribute derivative works only under a license identical
% ("not more restrictive") to the license that governs the original work.
% NC (Non-commercial): 	Licensees may copy, distribute, display, and perform the work and
% make derivative works and remixes based on it only for non-commercial purposes.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [moTQAt,moTQPt,moTQICt,moTQFt,moTQMt,moTQTt,...
    moqat,moqpt,moqict,moqft,moqmt]=...
    Growth_Obs(Lsqr,comp,T,mxTob,Tob,TQAt,TQPt,TQICt,TQFt,TQMt,TQTt,...
    qat,qpt,qict,qft,qmt,TQAob,TQPob,TQICob,TQFob,TQMob,TQTob,qaob,qpob,qicob,qfob,qmob,...
   pa,pp,pe,pc,pf,pm,pt)
moTQAt=zeros(T,1);moTQICt=zeros(T,1);moTQTt=zeros(T,1);

moqat=zeros(T,mxTob);moqpt=moqat;moqict=moqat;
moqatdata=moqat;moqptdata=moqpt;moqictdata=moqict;
if pp >0
    moTQPt=zeros(T,1);moqpt=moqat;moqptdata=moqat;
else
    moTQPt=0;moqpt=0;moqptdata=0;
end
if pf >0
    moTQFt=zeros(T,1);moqft=moqat;moqftdata=moqat;
else
    moTQFt=0;moqft=0;moqftdata=0;
end
if pm>0
    moTQMt=zeros(T,1);moqmt=moqat;moqmtdata=moqat;
else
    moTQMt=0;moqmt=0;moqmtdata=0;
end
if comp(1,1) >0
    x=1;i=1; % conditionning global biomass
    while i <= T;
        if i == abs(Tob(1,x))
            moTQAt(i,1)=TQAt(i,1);
            if pp >0
                moTQPt(i,1)=TQPt(i,1);
            end
            moTQICt(i,1)=TQICt(i,1);
            if pf >0
                moTQFt(i,1)=TQFt(i,1);
            end
            if pm >0
                moTQMt(i,1)=TQMt(i,1);
            end
            moTQTt(i,1)=TQTt(i,1);
            if TQAob(i,1)== 999
                moTQAt(i,1) =999;
            end
            if pp >0
                if TQPob(i,1)== 999
                    moTQPt(i,1) =999;
                end
            end
            if TQICob(i,1)== 999
                moTQICt(i,1) =999;
            end
            if pf >0
                if TQFob(i,1)== 999
                    moTQFt(i,1) =999;
                end
            end
            if pm >0
                if TQMob(i,1)== 999
                    moTQMt(i,1) =999;
                end
            end
            if TQTob(i,1)== 999
                moTQTt(i,1) =999;
            end
            if x == size(Tob)
                i =T+1;
            else
                x=x+1;
            end
        end
        i=i+1;
    end
end
if comp(1,2) >0
    x1=1;
    for i=1:T %
        if i == abs(Tob(1,x1)) &&  Tob(1,x1) >0
            for j=1:T
                moqat(j,x1)=qat(j,i);
                moqatdata(j,x1)=moqat(j,x1);
                if pp >0
                    moqpt(j,x1)=qpt(j,i);
                    moqptdata(j,x1)=moqpt(j,x1);
                end
                moqict(j,x1)=qict(j,i);%pith +layer
                moqictdata(j,x1)= moqict(j,x1);
                if pf >0
                    moqft(j,x1)=qft(j,i);
                    moqftdata(j,x1)=moqft(j,x1);
                end
                if pm >0
                    moqmt(j,x1)=qmt(j,i);
                    moqmtdata(j,x1)=moqmt(j,x1);
                end
                if Lsqr ==1
                    if qaob(j,x1) == 999
                        moqatdata(j,x1)=999;
                    end
                    if qaob(j,x1) == -0.0001
                        moqat(j,x1)=-0.0001;
                        moqatdata(j,x1)=-0.0001;
                    end
                    if qaob(j,x1) == -1
                        moqat(j,x1)=-1;
                        moqatdata(j,x1)=-1;
                    end
                    %if moqat(j,x1)==0 moqat(j,x1)=-0.0001;end
                    if pp >0
                        if qpob(j,x1) == 999
                            moqptdata(j,x1)=999;
                        end
                        if qpob(j,x1) == -0.0001
                            moqpt(j,x1)=-0.0001;
                            moqptdata(j,x1)=-0.0001;
                        end
                        if qpob(j,x1) == -1
                            moqpt(j,x1)=-1;
                            moqptdata(j,x1)=-1;
                        end
                        %if moqpt(j,x1)==0 moqpt(j,x1)=-0.0001;end
                    end
                    if pe+pc>0 >0
                        if qicob(j,x1) == 999
                            moqictdata(j,x1)=999;
                        end
                        if qicob(j,x1) == -0.0001
                            moqict(j,x1)=-0.0001;
                            moqictdata(j,x1)=-0.0001;
                        end
                        if qicob (j,x1) == -1
                            moqict(j,x1)=-0.0001;
                            moqictdata(j,x1)=-0.0001;
                        end
                    end
                    if pf >0
                        if qfob(j,x1) == 999
                            moqftdata(j,x1)=999;
                        end
                        if qfob(j,x1) == -0.0001
                            moqft(j,x1)=-0.0001;
                            moqftdata(j,x1)=-0.0001;
                        end
                        if qfob(j,x1) == -1
                            moqftdata(j,x1)=-1;
                        end
                    end
                    if pm >0
                        if qmob(j,x1) == 999
                            moqmtdata(j,x1)=999;
                        end
                        if qmob(j,x1) == -0.0001
                            moqmtdata(j,x1)=-0.0001;
                        end
                        if qmob(j,x1) == -1
                            moqmtdata(j,x1)=-1;
                        end
                        %if moqbms(j,x1)==0 moqmt(j,x1)=-0.0001;end
                    end
                end % Lsqr
            end
        end % if i == abs(Tob(1,x1)) &  Tob(1,x1) >0
        if i == abs(Tob(1,x1)) && x1 < mxTob
            x1=x1+1;
        end
    end % i
end

%






