%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% StemGL_Fit Single stem Greenlab Fitting tool and
% StemGL_Sim Single stem GreenLab Simulation tool
%
%   MatLab_Octave code. 
%
% This code is part of GREENLAB project StemGL implementation
%
% Main Author: Philippe de Reffye CIRAD-AMAP
% Secondary author: Marc JAEGER CIRAD-AMAP
%
% Created: 2018
% Version 18_10_05
%
% Copyright (C) 2018 CIRAD-AMAP 
%
% This program is free software: you can redistribute it and/or modify it
% under the terms of the Create Commons Licence  type 5, BY-NC-SA
% BY (Attribution): Licensees may copy, distribute, display and perform the work and make derivative
% works and remixes based on it only if they give the author or licensor the credits (attribution)
% in the manner specified by these.
% SA (Share-alike): Licensees may distribute derivative works only under a license identical
% ("not more restrictive") to the license that governs the original work.
% NC (Non-commercial): 	Licensees may copy, distribute, display, and perform the work and
% make derivative works and remixes based on it only for non-commercial purposes.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [WDD] = fit_invmat(LL, WCC)
%double(WDD);
%REM initialisation
for i = 1 :LL
   for j = 1 :LL
      WDD(i, j) = 0;
   end
   WDD(i, i) = 1; WPP(i) = 0;
end
%REM invert matrix WCC^-1 -->WDD
for k = 1 :LL - 1
   for i = k+1 :LL
      for j = LL:-1:k 
         if WCC(k, k) == 0
            sprintf('WCC is zero');
         end
         WCC(i, j) = WCC(i, j) - WCC(i, k) * WCC(k, j) / WCC(k, k);
         if j == LL
            for l = 1 :LL
               WDD(i, l) = WDD(i, l) - WDD(k, l) * WCC(i, k) / WCC(k, k);
            end
         end
      end
   end
end

for k = 1 :LL
   for i= LL:-1:1
      s = 0;
      for j = i: LL
         s = s + WCC(i, j) * WPP(j);
      end
      WDD(i, k) = (WDD(i, k) - s) / WCC(i, i);
      WPP(i) = WDD(i, k);
   end
   for i = 1 :LL
      WPP(i) = 0;
   end
end
