%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% StemGL_Fit Single stem Greenlab Fitting tool and
% StemGL_Sim Single stem GreenLab Simulation tool
%
%   MatLab_Octave code. 
%
% This code is part of GREENLAB project StemGL implementation
%
% Main Author: Philippe de Reffye CIRAD-AMAP
% Secondary author: Marc JAEGER CIRAD-AMAP
%
% Created: 2018
% Version 18_10_05
%
% Copyright (C) 2018 CIRAD-AMAP 
%
% This program is free software: you can redistribute it and/or modify it
% under the terms of the Create Commons Licence  type 5, BY-NC-SA
% BY (Attribution): Licensees may copy, distribute, display and perform the work and make derivative
% works and remixes based on it only if they give the author or licensor the credits (attribution)
% in the manner specified by these.
% SA (Share-alike): Licensees may distribute derivative works only under a license identical
% ("not more restrictive") to the license that governs the original work.
% NC (Non-commercial): 	Licensees may copy, distribute, display, and perform the work and
% make derivative works and remixes based on it only for non-commercial purposes.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [WPAR,WDEVPAR,WEPAR,EQUI,NPAR,DSPAR1,DSPAR2] = fit_lsqr_par(NVAR,XPAR,XDEVPAR,XEPAR,...
    WPAR,WDEVPAR,WEPAR,EQUI,NPAR,SPAR)
%  number of parameters choosen and initial variables
NPAR = 0;
for i = 1:NVAR
   NPAR = NPAR + XPAR(i, 1);
   XPAR(i,3) = XPAR(i,2);
end

% if NPAR == 0 THEN PRINT "pas de parametres": STOP
% processing selections of parameters for least square method
ISPAR=cellstr(SPAR);DSPAR1='';DSPAR2='';
k = 0;
for i = 1:NVAR  
   EQUI(i,1) = k;
   if XPAR(i, 1) > 0
      k = k + 1;
      WPAR(k, 1) = XPAR(i, 2);%choosen parameter to fit
      WDEVPAR(k,1) = XDEVPAR(i,1);% initial deviation
      WEPAR(k,1) = XEPAR(i,1);% increment for numerical derivative
      EQUI(i,1) = k;
      if k <9
          DSPAR1=strcat(DSPAR1,ISPAR(i));
      else
        DSPAR2=strcat(DSPAR2,ISPAR(i));  
      end
   end
end  
k=0;
%%%
