%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% StemGL_Fit Single stem Greenlab Fitting tool and
% StemGL_Sim Single stem GreenLab Simulation tool
%
%   MatLab_Octave code. 
%
% This code is part of GREENLAB project StemGL implementation
%
% Main Author: Philippe de Reffye CIRAD-AMAP
% Secondary author: Marc JAEGER CIRAD-AMAP
%
% Created: 2018
% Version 18_10_05
%
% Copyright (C) 2018 CIRAD-AMAP 
%
% This program is free software: you can redistribute it and/or modify it
% under the terms of the Create Commons Licence  type 5, BY-NC-SA
% BY (Attribution): Licensees may copy, distribute, display and perform the work and make derivative
% works and remixes based on it only if they give the author or licensor the credits (attribution)
% in the manner specified by these.
% SA (Share-alike): Licensees may distribute derivative works only under a license identical
% ("not more restrictive") to the license that governs the original work.
% NC (Non-commercial): 	Licensees may copy, distribute, display, and perform the work and
% make derivative works and remixes based on it only for non-commercial purposes.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%
%histogrammes biomass
function[xx]=plot_HistoS(comp,E,T,N,Tob,mxTob,pa,pp,pe,pc,pf,pm,pq,pt,...
    Xas,Axdc,Dsm,Ds,Qsm,Qs,TQS,TQAS,TQPS,TQIS,TQICS,TQFS,TQMS,TQRS,TQTS,...
    qasm,qpsm,qism,qicsm,qfsm,qmsm,qas,qps,qis,qics,qfs,qms,...
    txa,txp,txi,txc,txf,txm,txt,Ba,Bp,Bi,Bc,Bf,Bm,Bt,Dla,Dlp,Dli,Dlc,Dlf,Dlm,Dlt)
fg=1;
figure (fg);
set (figure (fg), 'Name', 'Plant functionning results');
subplot(2,2,1)
plot(E,'k','LineWidth',2)
title ('climate factor')
hold on
subplot(2,2,2)
plot(Xas,'-o k','LineWidth',2,'markersize',3)
title('number of phytomers')
hold on
%%% Demande average (simulation)
XDs=[0,T]; 
YDs=[0,0];
plot(XDs,YDs,'- w');
hold on
subplot(2,2,3)
maxDs=max(Dsm(:,1));maxDs=maxDs+maxDs/4;
XDs=[0,T];
YDs=[maxDs,maxDs];
plot(XDs,YDs,'- w');
hold on
plot(Dsm,'-o k','LineWidth',2,'markersize',3)
hold on
%%% Demand random details
ns=20;
if ns >N
    ns =N;
end
plot(0,0)
hold on
for i=1 :ns
    plot(Ds(:,i),'-- g')
    hold on
end
title (' average and individual Demand')
subplot(2,2,4)
%%% simulated average biomass
plot(Qsm,'-o k','LineWidth',2,'markersize',3)
hold on
%%% Biomass random details
for i=1 :ns
    plot(Qs(:,i),'-- g')
    hold on
end
title (' average and individual biomass product.')
fg=fg+1;
%%%%%%%%%%%% organ expansion time
figure (fg)
set (figure (fg), 'Name', 'organ expansion time/rank');
for t =1:T
    TT(t,1)=t;TX(t,1)=max(txa(t,:));
end
subplot(2,3,1)
plot(0,0)
hold on
plot(1,max(txa(T,:))+5)
hold on
plot(TT(:,1),TX(:,1),'- g','LineWidth',2);
title ('leaf expansion time')
hold on
if pp >0
    for t =1:T
        TT(t,1)=t;TX(t,1)=max(txp(t,:));
    end
    subplot(2,3,2)
    plot(0,0)
    hold on
    plot(1,max(txp(T,:))+5)
    hold on
    plot(TT(:,1),TX(:,1),'- b','LineWidth',2);
    title ('petiol sheath expansion time')
    hold on
end
if pe >0
    for t =1:T
        TT(t,1)=t;TX(t,1)=max(txi(t,:));
    end
    subplot(2,3,3)
    plot(0,0)
    hold on
    plot(1,max(txi(T,:))+5)
    hold on
    plot(TT(:,1),TX(:,1),'- b','LineWidth',2);
    title ('internode expansion time')
    hold on
end
if pf >0
    for t =1:T
        TT(t,1)=t;TX(t,1)=max(txf(t,:));
    end
    subplot(2,3,4)
    plot(0,0)
    hold on
    plot(1,max(txf(T,:))+5)
    hold on
    plot(TT(:,1),TX(:,1),'- r','LineWidth',2);
    title ('fruit fem. expansion time')
    hold on
end
if pm >0
    for t =1:T
        TT(t,1)=t;TX(t,1)=max(txm(t,:));
    end
    subplot(2,3,5)
    plot(0,0)
    hold on
    plot(1,max(txm(T,:))+5)
    hold on
    plot(TT(:,1),TX(:,1),'- c','LineWidth',2);
    title ('fruit mal. expansion time')
    hold on
end
if pt >0
    for t =1:T
        TT(t,1)=t;TX(t,1)=max(txt(t,:));
    end
    subplot(2,3,6)
    plot(0,0)
    hold on
    plot(1,max(txt(T,:))+5)
    hold on
    plot(TT(:,1),TX(:,1),'- m','LineWidth',2);
    title ('root expansion time')
end
hold off
fg=fg+1;
%%%%%%%%%% sink variation law of organ
set(figure (fg), 'Name', 'Sink variation law');
if max(txa) >T
    St=T;
else
    St=max(txa);
end
SinkOrg=zeros(1,Dla+St);Borga=zeros(1,St);
for s =1:St+Dla
    Borga(1,s)=Ba(T,s)*pa;
    SinkOrg(1,s+Dlp)=Borga(1,s);
end
subplot(2,3,1)
plot(0,0)
hold on
plot(0,max(SinkOrg)+0.2)
hold on
plot(SinkOrg,'- g','LineWidth',2);
title('leaf sink variation')
hold on
if max(txp) >T
    St=T;
else
    St=max(txp);
end
if pp >0
    SinkOrg=zeros(1,Dlp+St);Borgp=zeros(1,St);
    for s =1:St+Dlp
        Borgp(1,s)=Bp(T,s)*pp;
        SinkOrg(1,s+Dlp)=Borgp(1,s);
    end
    subplot(2,3,2)
    plot(0,0)
    hold on
    plot(0,max(SinkOrg)+0.5)
    hold on
    plot(SinkOrg,'-- g','LineWidth',2);
    title('petiol-sheath sink variation')
    hold on
end
if pe >0 && max(txi)>0
    if max(txi) >T
        St=T;
    else
        St=max(txi);
    end
    SinkOrg=zeros(1,Dli+St);Borgi=zeros(1,St);
    for s =1:St+Dli
        Borgi(1,s)=Bi(T,s)*pe;
        SinkOrg(1,s+Dli)=Borgi(1,s);
    end
    subplot(2,3,3)
    plot(0,0)
    hold on
    plot(0,max(SinkOrg)+0.2)
    hold on
    plot(SinkOrg,'- b','LineWidth',2);
    title('internode sink variation')
    hold on
end
if pf >0
    if max(txf) >T
        St=T;
    else
        St=max(txf);
    end
    SinkOrg=zeros(1,Dlf+St);Borgf=zeros(1,St);
    for s =1:St%
        Borgf(1,s)=Bf(T,s)*pf;
        SinkOrg(1,s+Dlf)=Borgf(1,s);
    end
    subplot(2,3,4)
    plot(0,0)
    hold on
    plot(0,max(SinkOrg)+0.2)
    hold on
    plot(SinkOrg,'- r','LineWidth',2);
    title('fruit fem. sink variation')
    hold on
end
if pm >0
    if max(txm) >T
        St=T;
    else
        St=max(txm);
    end
    SinkOrg=zeros(1,Dlm+St);Borgm=zeros(1,St);
    for s =1:St+Dlm
        Borgm(1,s)=Bm(T,s)*pm;
        SinkOrg(1,s+Dlm)=Borgm(1,s);
    end
    subplot(2,3,5)
    plot(0,0)
    hold on
    plot(0,max(SinkOrg)+0.2)
    hold on
    plot(SinkOrg,'- c','LineWidth',2);
    title('fruit mal. sink variation')
    hold on
end
if pt >0
    if max(txt) >T
        St=T;
    else
        St=max(txt);
    end
    SinkOrg=zeros(1,Dlt+St);Borgt=zeros(1,St);
    for s =1:St
        Borgt(1,s)=Bt(T,s)*pt;
        SinkOrg(1,s+Dlt)=Borgt(1,s);
    end
    subplot(2,3,6)
    plot(0,0)
    hold on
    plot(0,max(SinkOrg)+0.5)
    hold on
    plot(SinkOrg,'- m','LineWidth',2);
    title('root sink variation')
end
hold off
fg=fg+1;
hold off
fg=fg+1;
if comp(1,1) >0
    % %%%Theoretical biomass
    figure (fg)
    set (figure (fg), 'Name', 'biomass/compartment leaf  g, internode k, fruit r,pool, tape root m');
    subplot(2,3,1)
    %%%% leaf
    plot(TQAS,'-o g','markersize',3)
    title ('leaf petiol bmass comp.')
    hold on
    % petiol
    if pp >0
        plot(TQPS,'-* g','markersize',3)
        hold on
    end
    %%%% internode pith+rings
    if pe >0
        subplot(2,3,2)
        plot(TQIS,'-* b','markersize',3)
        hold on
        plot(TQICS,'-o b','markersize',3)
        title ('intern. bmass comp.')
        hold on
    end
    if pf >0
        subplot(2,3,3)
        %%%% fruits fem
        plot(TQFS,'-o r','markersize',3)
        title ('fruit fem.mal. bmass comp.')
        hold on
    end 
    if pm >0
        %%%% fruits mal
        plot(TQMS,'-* c','markersize',3)
        hold on
    end
    if pq >0
        subplot(2,3,4)
        %%%% common pool
        plot(TQRS,'-o c','markersize',3)
         title ('pool. bmass comp.')
        hold on
    end
    if pt >0
        %%%% Tape root
        subplot(2,3,5)
        plot(TQTS,'-o m','markersize',3)
        title ('root biomass comp.')
    end
  %  total
  subplot(2,3,6)
  plot(TQS,'-o k','markersize',3)
  hold on
  plot(TQAS,'-o g','markersize',3)
  hold on
  plot(TQICS,'-o b','markersize',3)
  hold on
  plot(TQFS,'-o r','markersize',3)
  hold on
  plot(TQTS,'-o m','markersize',3)
  hold on
  plot(TQRS,'-o c','markersize',3)
  title ('All biomass comp.')
  hold off
end
fg=fg+1;
%%%%%%%%%%%%%%%%%%
% mean of blade organic series chronological at T GC
figure (fg)
set (figure (fg), 'Name', 'Organ chronological organic series');
subplot(2,2,1)
plot (qasm(T,:),'-o g','markersize',3)
hold on
if pp >0
    plot (qpsm(T,:),'-* g','markersize',3)
end
title('blade o, petiol *')
hold on
%%%%%%%%%%%%%%%%%%
% mean of internode organic series chronological at T GC
if pe >0
    subplot(2,2,2)
    plot (qism(T,:),'-* b','markersize',3)
    hold on
    if pc >0
        % mean of internode organic series chronological at T GC
        plot (qicsm(T,:),'-o b','markersize',3)
    end
    title ( 'pith * intern.rings o')
end
% mean of fruit organic series chronological at T GC
if pf >0
    subplot(2,2,3)
    plot (qfsm(T,:),'-o r','markersize',3)
    title(' fruits fem  o')
    hold on
end
if pm >0
    plot (qmsm(T,:),'-* c','markersize',3)
    title(' fruits mal *')
end

hold off
fg=fg+1;
%%%%%%%%%%%%%%%%%%
% series organic simulated topological
%%%%%%%%%%%%%%%%%%%%
figure (fg)
set (figure (fg), 'Name', 'Organ topological organic series');
% blade+petiol
subplot(2,2,1)
qo=zeros(T,1);
for k=1:mxTob
    Ti=Tob(1,k);
    [qasmt] =selectS(T,Ti,N,Axdc,qas);
    qot=qasmt';
    [qot]=crunchq_upqos(qot,T);
    plot (qot(:,1),'-o g','markersize',3)
    hold on
end
if pp>0
    for k=1:mxTob
        Ti=Tob(1,k);
        [qpsmt] =selectS(T,Ti,N,Axdc,qps);
        qot=qpsmt';
        [qot]=crunchq_upqos(qot,T);
        plot (qot(:,1),'-* b','markersize',3)
        hold on
    end
end
title ('leaf o petiol *')
hold on
% internode (pith+rings)
if pe >0
    subplot(2,2,2)
    for k=1:mxTob
        Ti=Tob(1,k);
        [qismt] =selectS(T,Ti,N,Axdc,qis);
        qot=qismt';
        [qot]=crunchq_upqos(qot,T);
        plot (qot(:,1),'-* b','markersize',3)
        hold on
    end
    for k=1:mxTob
        Ti=Tob(1,k);
        [qicsmt] =selectS(T,Ti,N,Axdc,qics);
        qot=qicsmt';
        [qot]=crunchq_upqos(qot,T);
        plot (qot(:,1),'-o b','markersize',3)
        hold on
    end
    title ('pith * +rings o')
end
if pf >0 || pm >0
    % female fruit
    subplot(2,2,3)
    if pf >0
        for k=1:mxTob
            Ti=Tob(1,k);
            [qfsmt] =selectS(T,Ti,N,Axdc,qfs);
            qot=qfsmt';
            [qot]=crunchq_upqos(qot,T);
            plot (qot(:,1),'-o r','markersize',3)
            hold on
        end
    end

    if pm >0
        % male fruit
        for k=1:mxTob
            Ti=Tob(1,k);
            [qmsmt] =selectS(T,Ti,N,Axdc,qms);
            qot=qmsmt';
            [qot]=crunchq_upqos(qot,T);
            plot (qot(:,1),'-* c','markersize',3)
            hold on
        end
    end
title(' fruits f. o m. c')
end
xx=0;